'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var umiWeb3jsAdapters = require('@metaplex-foundation/umi-web3js-adapters');
var web3_js = require('@solana/web3.js');

class Web3JsTransactionFactory {
  create(input) {
    const web3JsMessage = umiWeb3jsAdapters.toWeb3JsMessageFromInput(input);
    const web3JsTransaction = new web3_js.VersionedTransaction(web3JsMessage, input.signatures);
    return {
      message: umiWeb3jsAdapters.fromWeb3JsMessage(web3JsMessage),
      serializedMessage: web3JsMessage.serialize(),
      signatures: web3JsTransaction.signatures
    };
  }
  serialize(transaction) {
    return umiWeb3jsAdapters.toWeb3JsTransaction(transaction).serialize();
  }
  deserialize(serializedTransaction) {
    return umiWeb3jsAdapters.fromWeb3JsTransaction(web3_js.VersionedTransaction.deserialize(serializedTransaction));
  }
  serializeMessage(message) {
    return new Uint8Array(umiWeb3jsAdapters.toWeb3JsMessage(message).serialize());
  }
  deserializeMessage(serializedMessage) {
    return umiWeb3jsAdapters.fromWeb3JsMessage(web3_js.VersionedMessage.deserialize(serializedMessage));
  }
}

exports.Web3JsTransactionFactory = Web3JsTransactionFactory;
//# sourceMappingURL=Web3JsTransactionFactory.cjs.map
